SystemOrganization addCategory: #'ToolsTest-Inspector'!
SystemOrganization addCategory: #'ToolsTest-PointerFinder'!

TestCase subclass: #PointerFinderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolsTest-PointerFinder'!

!PointerFinderTest methodsFor: 'as yet unclassified' stamp: 'Alexandre.Bergel 7/4/2009 11:14'!
testBasic1

	| myObject myArray |
	myObject := Object new.
	myArray := {myObject . myObject}.
	self assert: (PointerFinder pointersTo: myObject) asArray = {myArray}! !

!PointerFinderTest methodsFor: 'as yet unclassified' stamp: 'Alexandre.Bergel 7/4/2009 11:24'!
testCycle

	| myObject myArray myArray2 pointingObjects |
	myObject := Object new.
	myArray := {myObject . myObject}.
	myArray2 := {myObject . myArray}.

	pointingObjects := (PointerFinder pointersTo: myObject) asArray.
	self assert: pointingObjects size = 2.
	self assert: (pointingObjects includesAllOf: {myArray . myArray2}).
	
	"PointerFinder loops in presence of cycles"
"	myArray at: 1 put: myArray.
	pointingObjects := (PointerFinder pointersTo: myObject) asArray.
	self assert: pointingObjects = {myArray}.
"! !

!PointerFinderTest methodsFor: 'as yet unclassified' stamp: 'Alexandre.Bergel 7/4/2009 11:13'!
testNoPointingObject

	| myObject |
	myObject := Object new.
	self assert: (PointerFinder pointersTo: myObject) isEmpty! !

TestCase subclass: #WeakSetInspectorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolsTest-Inspector'!

!WeakSetInspectorTest methodsFor: 'testing' stamp: 'AdrianLienhard 1/21/2010 22:07'!
testSymbolTableM6812
	"this test is related to http://bugs.squeak.org/view.php?id=6812"
	
	| aWeakSet anInspector fieldSize |
	aWeakSet := (Symbol classPool at: #SymbolTable).
	anInspector := WeakSetInspector inspect: aWeakSet.
	
	fieldSize := anInspector fieldList size.
	3 timesRepeat:
		[Smalltalk garbageCollect.
		self assert: fieldSize = anInspector fieldList size.]
	! !
